/**
 */
package tools.descartes.prisma.agent.generic.genericagent;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentFactory
 * @model kind="package"
 * @generated
 */
public interface GenericAgentPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "genericagent";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/prisma/genericagent/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "genericagent";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	GenericAgentPackage eINSTANCE = tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentConfigurationImpl <em>Configuration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentConfigurationImpl
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getGenericAgentConfiguration()
	 * @generated
	 */
	int GENERIC_AGENT_CONFIGURATION = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__ID = 0;

	/**
	 * The feature id for the '<em><b>Scope</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__SCOPE = 1;

	/**
	 * The feature id for the '<em><b>Required Objects</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__REQUIRED_OBJECTS = 2;

	/**
	 * The feature id for the '<em><b>Skeleton</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__SKELETON = 3;

	/**
	 * The feature id for the '<em><b>Delegations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION__DELEGATIONS = 4;

	/**
	 * The number of structural features of the '<em>Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION_FEATURE_COUNT = 5;

	/**
	 * The number of operations of the '<em>Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_AGENT_CONFIGURATION_OPERATION_COUNT = 0;


	/**
	 * The meta object id for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.RequiredObjectImpl <em>Required Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.RequiredObjectImpl
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getRequiredObject()
	 * @generated
	 */
	int REQUIRED_OBJECT = 1;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_OBJECT__OBJECT = 0;

	/**
	 * The feature id for the '<em><b>Exchange</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_OBJECT__EXCHANGE = 1;

	/**
	 * The number of structural features of the '<em>Required Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_OBJECT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Required Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIRED_OBJECT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.DelegationDestinationImpl <em>Delegation Destination</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.DelegationDestinationImpl
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getDelegationDestination()
	 * @generated
	 */
	int DELEGATION_DESTINATION = 2;

	/**
	 * The feature id for the '<em><b>Exchange</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_DESTINATION__EXCHANGE = 0;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_DESTINATION__DESTINATION = 1;

	/**
	 * The feature id for the '<em><b>Patterns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_DESTINATION__PATTERNS = 2;

	/**
	 * The number of structural features of the '<em>Delegation Destination</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_DESTINATION_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Delegation Destination</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELEGATION_DESTINATION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.RoutingKeyPatternImpl <em>Routing Key Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.RoutingKeyPatternImpl
	 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getRoutingKeyPattern()
	 * @generated
	 */
	int ROUTING_KEY_PATTERN = 3;

	/**
	 * The feature id for the '<em><b>Pattern</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTING_KEY_PATTERN__PATTERN = 0;

	/**
	 * The number of structural features of the '<em>Routing Key Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTING_KEY_PATTERN_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Routing Key Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROUTING_KEY_PATTERN_OPERATION_COUNT = 0;

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration <em>Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Configuration</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration
	 * @generated
	 */
	EClass getGenericAgentConfiguration();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getId()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EAttribute getGenericAgentConfiguration_Id();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getScope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scope</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getScope()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EReference getGenericAgentConfiguration_Scope();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getRequiredObjects <em>Required Objects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Required Objects</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getRequiredObjects()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EReference getGenericAgentConfiguration_RequiredObjects();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getSkeleton <em>Skeleton</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Skeleton</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getSkeleton()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EReference getGenericAgentConfiguration_Skeleton();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getDelegations <em>Delegations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Delegations</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration#getDelegations()
	 * @see #getGenericAgentConfiguration()
	 * @generated
	 */
	EReference getGenericAgentConfiguration_Delegations();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.agent.generic.genericagent.RequiredObject <em>Required Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Required Object</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RequiredObject
	 * @generated
	 */
	EClass getRequiredObject();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.prisma.agent.generic.genericagent.RequiredObject#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RequiredObject#getObject()
	 * @see #getRequiredObject()
	 * @generated
	 */
	EReference getRequiredObject_Object();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.prisma.agent.generic.genericagent.RequiredObject#getExchange <em>Exchange</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Exchange</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RequiredObject#getExchange()
	 * @see #getRequiredObject()
	 * @generated
	 */
	EAttribute getRequiredObject_Exchange();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.agent.generic.genericagent.DelegationDestination <em>Delegation Destination</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Delegation Destination</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.DelegationDestination
	 * @generated
	 */
	EClass getDelegationDestination();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.prisma.agent.generic.genericagent.DelegationDestination#getExchange <em>Exchange</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Exchange</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.DelegationDestination#getExchange()
	 * @see #getDelegationDestination()
	 * @generated
	 */
	EAttribute getDelegationDestination_Exchange();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.prisma.agent.generic.genericagent.DelegationDestination#getDestination <em>Destination</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Destination</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.DelegationDestination#getDestination()
	 * @see #getDelegationDestination()
	 * @generated
	 */
	EReference getDelegationDestination_Destination();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.prisma.agent.generic.genericagent.DelegationDestination#getPatterns <em>Patterns</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Patterns</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.DelegationDestination#getPatterns()
	 * @see #getDelegationDestination()
	 * @generated
	 */
	EReference getDelegationDestination_Patterns();

	/**
	 * Returns the meta object for class '{@link tools.descartes.prisma.agent.generic.genericagent.RoutingKeyPattern <em>Routing Key Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Routing Key Pattern</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RoutingKeyPattern
	 * @generated
	 */
	EClass getRoutingKeyPattern();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.prisma.agent.generic.genericagent.RoutingKeyPattern#getPattern <em>Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Pattern</em>'.
	 * @see tools.descartes.prisma.agent.generic.genericagent.RoutingKeyPattern#getPattern()
	 * @see #getRoutingKeyPattern()
	 * @generated
	 */
	EAttribute getRoutingKeyPattern_Pattern();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	GenericAgentFactory getGenericAgentFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentConfigurationImpl <em>Configuration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentConfigurationImpl
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getGenericAgentConfiguration()
		 * @generated
		 */
		EClass GENERIC_AGENT_CONFIGURATION = eINSTANCE.getGenericAgentConfiguration();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_AGENT_CONFIGURATION__ID = eINSTANCE.getGenericAgentConfiguration_Id();

		/**
		 * The meta object literal for the '<em><b>Scope</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_AGENT_CONFIGURATION__SCOPE = eINSTANCE.getGenericAgentConfiguration_Scope();

		/**
		 * The meta object literal for the '<em><b>Required Objects</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_AGENT_CONFIGURATION__REQUIRED_OBJECTS = eINSTANCE.getGenericAgentConfiguration_RequiredObjects();

		/**
		 * The meta object literal for the '<em><b>Skeleton</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_AGENT_CONFIGURATION__SKELETON = eINSTANCE.getGenericAgentConfiguration_Skeleton();

		/**
		 * The meta object literal for the '<em><b>Delegations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERIC_AGENT_CONFIGURATION__DELEGATIONS = eINSTANCE.getGenericAgentConfiguration_Delegations();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.RequiredObjectImpl <em>Required Object</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.RequiredObjectImpl
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getRequiredObject()
		 * @generated
		 */
		EClass REQUIRED_OBJECT = eINSTANCE.getRequiredObject();

		/**
		 * The meta object literal for the '<em><b>Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REQUIRED_OBJECT__OBJECT = eINSTANCE.getRequiredObject_Object();

		/**
		 * The meta object literal for the '<em><b>Exchange</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REQUIRED_OBJECT__EXCHANGE = eINSTANCE.getRequiredObject_Exchange();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.DelegationDestinationImpl <em>Delegation Destination</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.DelegationDestinationImpl
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getDelegationDestination()
		 * @generated
		 */
		EClass DELEGATION_DESTINATION = eINSTANCE.getDelegationDestination();

		/**
		 * The meta object literal for the '<em><b>Exchange</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DELEGATION_DESTINATION__EXCHANGE = eINSTANCE.getDelegationDestination_Exchange();

		/**
		 * The meta object literal for the '<em><b>Destination</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DELEGATION_DESTINATION__DESTINATION = eINSTANCE.getDelegationDestination_Destination();

		/**
		 * The meta object literal for the '<em><b>Patterns</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DELEGATION_DESTINATION__PATTERNS = eINSTANCE.getDelegationDestination_Patterns();

		/**
		 * The meta object literal for the '{@link tools.descartes.prisma.agent.generic.genericagent.impl.RoutingKeyPatternImpl <em>Routing Key Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.RoutingKeyPatternImpl
		 * @see tools.descartes.prisma.agent.generic.genericagent.impl.GenericAgentPackageImpl#getRoutingKeyPattern()
		 * @generated
		 */
		EClass ROUTING_KEY_PATTERN = eINSTANCE.getRoutingKeyPattern();

		/**
		 * The meta object literal for the '<em><b>Pattern</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ROUTING_KEY_PATTERN__PATTERN = eINSTANCE.getRoutingKeyPattern_Pattern();

	}

} //GenericAgentPackage
